#pragma once

#include "v3.h"
#include "ppc.h"
#include "framebuffer.h"

class TMesh {
public:
  bool enabled;
  V3 *verts, *cols;
  int vertsN;
  unsigned int *tris;
  int trisN;
  TMesh() : enabled(true), verts(0), vertsN(0), tris(0), trisN(0), cols(0) {};
  void SetCube(V3 center, float sl);
  void Render(PPC *ppc, FrameBuffer *fb);
  void RenderWF(PPC *ppc, FrameBuffer *fb);
  void RenderPoints(PPC *ppc, FrameBuffer *fb, int pSize);
  void RotateAboutArbitraryAxis(V3 aO, V3 aDir, float theta);
  V3 GetCenter();
  void Load(char *fname);
  void Translate(V3 transv);
  void Scale(float scalef);
  void ScaleAboutCenter(float scalef);
  AABB GetAABB();
  void SetFromFB(FrameBuffer *fb, PPC *ppc);
};

